/// <reference types="react" />
import { BasicContainer } from '../base';
import { IFormContainer, IFormContainerProps } from '../../definition';
export declare class FormContainer extends BasicContainer<IFormContainerProps> implements IFormContainer {
    /**
     * @stable [03.02.2020]
     * @param {IFormContainerProps} props
     */
    constructor(props: IFormContainerProps);
    /**
     * @stable [03.02.2020]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [27.09.2019]
     */
    submit(): void;
    /**
     * @stable [17.02.2019]
     * @param {IFieldChangeEntity} payload
     */
    private onChange;
    /**
     * @stable [03.02.2020]
     * @param {boolean} valid
     */
    private onValid;
    /**
     * @stable [03.02.2020]
     */
    private onReset;
    /**
     * @stable [02.04.2019]
     * @param {IApiEntity} apiEntity
     */
    private onSubmit;
    /**
     * @stable [03.02.2020]
     * @param {IApiEntity} apiEntity
     * @returns {boolean}
     */
    private onBeforeSubmit;
    private onEmptyDictionary;
    private onLoadDictionary;
    /**
     * @stable [27.09.2019]
     * @returns {IForm}
     */
    private readonly form;
}
